/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.cc
 * Copyright (C) Chinmay 2010 <cyg2104@columbia.edu>
 * 
 * main.cc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.cc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "tou.h"
#include <fstream>
#include <sys/socket.h>
#include <netdb.h>
//using namespace std;

int main(int argc, char *argv[])
{
		tou tm;
		struct sockaddr_in	socket1;
		struct sockaddr_in	socket2;
		struct sockaddr_in	clientaddr;
		int sockd;

		memset(&socket2,0,sizeof(socket2));
		socket2.sin_family = AF_INET;
		socket2.sin_addr.s_addr = inet_addr("127.0.0.1");
		socket2.sin_port = htons(1501);
		memset(&socket1,0,sizeof(socket1));
		socket1.sin_family = AF_INET;
		socket1.sin_addr.s_addr = inet_addr("127.0.0.1");
		socket1.sin_port = htons(1502);

		cout <<"entering mode - " << endl;
		if(argc == 2 && !strncmp( argv[1], "-c", 2))
		{
				cout << "Client mode" << endl;
				
				sockd = tm.touSocket(AF_INET,SOCK_DGRAM,0);
			    cout << " Socket function returns " << sockd << endl;
			
				//sd = tm.touBind(sockd,(struct sockaddr*) &socket1,sizeof socket1);
				int res = tm.touBind (sockd,(struct sockaddr*) &socket2,sizeof socket2);
				cout << " Bind function returns " << res << endl;

				tm.touListen (sockd,5);
				
				res = tm.touConnect (sockd,(struct sockaddr_in*) &socket1,sizeof(socket1));
				cout << "Connect function returns : " << res << endl;
		}
		else if(argc==2 && !strncmp(argv[1], "-s", 2))
		{
				cout << "Server mode" << endl;
				sockd = tm.touSocket(AF_INET,SOCK_DGRAM,0);
			    cout << " Socket function returns " << sockd << endl;

				int res = tm.touBind (sockd,(struct sockaddr*) &socket1,sizeof socket1);
				cout << " Bind function returns " << res << endl;

				socklen_t sinlen = sizeof(clientaddr);

				int res1 = tm.touListen(sockd,2);
				if (res1 == -1) exit(0);
				//int res2 = tm.toufcntl(sockd,1,0);
				while(1)
				{

					tm.processTou (sockd);
					//int res2 = tm.toufcntl(sockd,1,0);  fcntl should be after accepting on the new fd
					// so dunno who it will decide if the accept function is blocking or not
					//sleep(10);
					res = tm.touAccept (sockd,(struct sockaddr_in*) &clientaddr,&sinlen);
					cout << "Accept function returns " << res << endl;

					if (res < 0)
					     cerr << "ERROR on accept" << endl;
					int pid = fork();
					cout << "######################" << endl;
					if (pid < 0)
					    cerr<< "ERROR on fork" << endl;
					if (pid == 0)
					{
						cout << "Inside server : " << pid << endl;
					    //close(sockfd);
					    //dostuff(newsockfd);
						sleep(5);
					    //exit(0);
					}
					cout << "Outside the loop " << endl;
				}
 		}
				
	return 0;
}
