/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * multitou
 * Copyright (C) Chinmay 2010 <>
 * 
 * multitou is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * multitou is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SOCKET_TABLE_H_
#define _SOCKET_TABLE_H_
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sstream>
#include <vector>
#include <string>
#include <map>
#include "tou-header.h"
#include "control-block.h"

class SocketTable : public touHeader
{
public:
	int	realfd;
	int lfd;
	int accfd;

	u_short	sport;
	u_short dport;      
	std::string sip;
	std::string dip;		

	int sockstate;
	touHeader *th;
	touCb *tc;
	void printall(int sd);

	SocketTable()
	{
		tc = new touCb();

	}
	//~SocketTable();
protected:

private:

};

#endif // _SOCKET_TABLE_H_
